#include <iostream>
#include "calc.h"

int main ()
{
    std::cout << '\n';
    std::cout << "  *************************************************\n";
    std::cout << "  *                                               *\n";
    std::cout << "  *  Calc version 0.031.                          *\n";
    std::cout << "  *  This program is course job by Jury Levykin.  *\n";
    std::cout << "  *  Last editing: 27.03.2004.                    *\n";
    std::cout << "  *                                               *\n";
    std::cout << "  *************************************************\n\n";

    std::cout << "To computing, please, input completed mathematical expression.\n";
    std::cout << "You can use digits, spaces and next characters: + - * / ( ).\n";
    std::cout << "To quit put q.\n\n";

    enum calcmode { calc, lang };

    calcmode mode = calc;

    std::string expr;
    std::string polexpr;

    bool errflag = false;
    double Res;

    while (true) {

/************** INPUT *********************************/

	if (mode == calc) {
	    std::cout << "calc> ";
	}
	else {
	    std::cout << "lang> ";
	}
	std::getline (std::cin, expr);

	if ( ! expr.compare ("q")    ||
	     ! expr.compare ("Q")    ||
	     ! expr.compare ("quit") ||
	     ! expr.compare ("exit") 
	) {
	    break;
	}
	else if (! expr.compare ("lang")) {
	    mode = lang;
	    continue;
	}
	else if (! expr.compare ("calc")) {
	    mode = calc;
	    continue;
	}
	else if (mode == lang) {
	    if (! langmain (expr)) {
		continue;
	    }
	}

/************** END INPUT *****************************/

/************** MAIN **********************************/

	spfilter (expr);
	if (errflag = ! brcheck (expr))
	    continue;
	if (errflag = ! syntaxcheck (expr))
	    continue;

	if (! errflag && expr.compare ("")) {
	    unaryrep (expr);
	    polexpr = exptopol (expr);
	    if (! compute (polexpr, Res))
		errflag = true;
	}

/************** END MAIN ******************************/

/************** OUTPUT ********************************/

	if (! errflag && expr.compare ("")) {
	    std::cout << expr << '\n';
	    std::cout << polexpr << '\n';
	    std::cout << "Result: " << Res << '\n';
	}

/************** END OUTPUT ****************************/

    }

    return 0;
}
